# Fallback resources
You can select an option by providing a fallback in addition to conditions. 
If the conditions are not met, fallbacks will be used. If the first callback can't be used, 
A later one will be tried. If none can be used, the resource will be ignored.
## Example
```json
{
    "conditions": [
        {
            "not": [
                "example:useAlternate"
            ]
        }
    ],
    "fallbacks": [
        "assets/minecraft/lang/en_us_alternate.json"
    ]

}
```
## Multiple alternatives
A fallback resource may provide their own conditions or fallbacks which will also be considered
and can be used to allow users to select one of multiple resources
