package io.gitlab.jfronny.respackopts.model.condition;

import java.util.List;
import java.util.Set;

public class XorConditionFactory implements CollectingConditionFactory {
    @Override
    public Condition build(List<Condition> conditions) {
        return packId -> {
            boolean bl = false;
            for (Condition condition : conditions) {
                if (condition.evaluate(packId))
                    bl = !bl;
            }
            return bl;
        };
    }

    @Override
    public Set<String> getNames() {
        return Set.of("^", "xor");
    }
}
