package io.gitlab.jfronny.respackopts.model.tree;

import io.gitlab.jfronny.respackopts.model.enums.PackReloadType;
import me.shedaniel.clothconfig2.api.ConfigEntryBuilder;
import net.minecraft.text.Text;

import java.util.Optional;
import java.util.function.Consumer;
import java.util.function.Supplier;

public record GuiEntryBuilderParam(ConfigEntryBuilder entryBuilder, Text name,
                                   Supplier<Optional<Text[]>> tooltipSupplier, String screenId, String entryName,
                                   String translationPrefix, Runnable onSave, Consumer<PackReloadType> agg) {
    public void saveCallback() {
        onSave.run();
    }
}